﻿/*	Application		Timers Demonstration - Timer event handlers executed asynchronously with respect to main()			
	File			Timers_Demonstration (Program.cs)
	Purpose			Demonstrates the basic concepts of programmable timers and event handlers
	Author			Richard John Anthony
	Date			January 2014
	
	Function		Creates three timers with periods of 1 second, 2 seconds and 3 seconds respectively
*/

using System;

namespace SystemTimers_experiment
{
    class Program
    {
        static void Main(string[] args)
        {
            System.Timers.Timer Timer1 = new System.Timers.Timer(); // Create first timer
            Timer1.Elapsed += new System.Timers.ElapsedEventHandler(OnTimedEvent_Timer1); // Set event handler method for first timer
            Timer1.Interval = 1000; // Set time interval to be 1 second (1000 ms)
            Timer1.Enabled = false;

            System.Timers.Timer Timer2 = new System.Timers.Timer(); // Create second timer
            Timer2.Elapsed += new System.Timers.ElapsedEventHandler(OnTimedEvent_Timer2); // Set event handler method for second timer
            Timer2.Interval = 2000; // Set time interval to be 2 seconds (2000 ms)
            Timer2.Enabled = false; // Do not start timer running yet

            System.Timers.Timer Timer3 = new System.Timers.Timer(); // Create third timer
            Timer3.Elapsed += new System.Timers.ElapsedEventHandler(OnTimedEvent_Timer3); // Set event handler method for third timer
            Timer3.Interval = 3000; // Set time interval to be 3 seconds (3000 ms)

            // Start all three timers 
            Timer1.Enabled = true;
            Timer2.Enabled = true;
            Timer3.Enabled = true;

            while (true)
            {
            }
        }

        private static void OnTimedEvent_Timer1(Object myObject, EventArgs myEventArgs)
        {
            Console.WriteLine("One second");
        }

        private static void OnTimedEvent_Timer2(Object myObject, EventArgs myEventArgs)
        {
            Console.WriteLine("            Two seconds");
        }

        private static void OnTimedEvent_Timer3(Object myObject, EventArgs myEventArgs)
        {
            Console.WriteLine("                         Three seconds");
        }
    }
}
